<?xml version="1.0" encoding="UTF-8"?>
<?eclipse version="3.0"?>

<plugin>

    <extension
            point="org.eclipse.ui.editors">
        <editor
              class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.XtextEditor"
              contributorClass="org.eclipse.ui.editors.text.TextEditorActionContributor"
              default="true"
              extensions="datatype"
              icon="icons/dsl_datatype.png"
              id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
              matchingStrategy="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.xbase.ui.editor.JavaEditorInputMatcher"
              name="OSBP DatatypeGrammar Editor">
        </editor>
    </extension>
    <extension
        point="org.eclipse.ui.handlers">
        <handler
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.hyperlinking.OpenDeclarationHandler"
            commandId="org.eclipse.xtext.ui.editor.hyperlinking.OpenDeclaration">
            <activeWhen>
                <reference
                    definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
                </reference>
            </activeWhen>
        </handler>
        <handler
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.handler.ValidateActionHandler"
            commandId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.validate">
         <activeWhen>
            <reference
                    definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
            </reference>
         </activeWhen>
      	</handler>
      	<!-- copy qualified name -->
        <handler
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedNameHandler"
            commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName">
            <activeWhen>
				<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened" />
            </activeWhen>
        </handler>
        <handler
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedNameHandler"
            commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedName">
            <activeWhen>
            	<and>
            		<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.XtextEditor.opened" />
	                <iterate>
						<adapt type="org.eclipse.xtext.ui.editor.outline.IOutlineNode" />
					</iterate>
				</and>
            </activeWhen>
        </handler>
    </extension>
    <extension point="org.eclipse.core.expressions.definitions">
        <definition id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
            <and>
                <reference definitionId="isActiveEditorAnInstanceOfXtextEditor"/>
                <with variable="activeEditor">
                    <test property="org.eclipse.xtext.ui.editor.XtextEditor.languageName" 
                        value="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar" 
                        forcePluginActivation="true"/>
                </with>        
            </and>
        </definition>
        <definition id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.XtextEditor.opened">
            <and>
                <reference definitionId="isXtextEditorActive"/>
                <with variable="activeEditor">
                    <test property="org.eclipse.xtext.ui.editor.XtextEditor.languageName" 
                        value="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar" 
                        forcePluginActivation="true"/>
                </with>        
            </and>
        </definition>
    </extension>
    <extension
            point="org.eclipse.ui.preferencePages">
        <page
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.preferences.LanguageRootPreferencePage"
            id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
            icon="icons/dsl_datatype.png"
            name="OSBP DatatypeGrammar">
            <keywordReference id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"/>
        </page>
        <page
            category="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.syntaxcoloring.SyntaxColoringPreferencePage"
            id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.coloring"
            name="Syntax Coloring">
            <keywordReference id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"/>
        </page>
        <page
            category="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.templates.XtextTemplatePreferencePage"
            id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.templates"
            name="Templates">
            <keywordReference id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"/>
        </page>
    </extension>
    <extension
            point="org.eclipse.ui.propertyPages">
        <page
              class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.preferences.LanguageRootPreferencePage"
              icon="icons/dsl_datatype.png"
              id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
              name="OSBP DatatypeGrammar">
            <keywordReference id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"/>
            <enabledWhen>
	            <adapt type="org.eclipse.core.resources.IProject"/>
			</enabledWhen>
	        <filter name="projectNature" value="org.eclipse.xtext.ui.shared.xtextNature"/>
        </page>
    </extension>
    <extension
        point="org.eclipse.ui.keywords">
        <keyword
            id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"
            label="DatatypeGrammar"/>
    </extension>
    <extension
         point="org.eclipse.ui.commands">
      <command
            description="Trigger expensive validation"
            id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.validate"
            name="Validate">
      </command>
      <!-- copy qualified name -->
      <command
            id="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName"
            categoryId="org.eclipse.ui.category.edit"
            description="Copy the qualified name for the selected element"
            name="Copy Qualified Name">
      </command>
      <command
            id="org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedName"
            categoryId="org.eclipse.ui.category.edit"
            description="Copy the qualified name for the selected element"
            name="Copy Qualified Name">
      </command>
    </extension>
    <extension point="org.eclipse.ui.menus">
        <menuContribution
            locationURI="popup:#TextEditorContext?after=group.edit">
             <command
                 commandId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.validate"
                 style="push"
                 tooltip="Trigger expensive validation">
            <visibleWhen checkEnabled="false">
                <reference
                    definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
                </reference>
            </visibleWhen>
         </command>  
         </menuContribution>
         <!-- copy qualified name -->
         <menuContribution locationURI="popup:#TextEditorContext?after=copy">
         	<command commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName" 
         		style="push" tooltip="Copy Qualified Name">
            	<visibleWhen checkEnabled="false">
                	<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened" />
            	</visibleWhen>
         	</command>  
         </menuContribution>
         <menuContribution locationURI="menu:edit?after=copy">
         	<command commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName"
            	style="push" tooltip="Copy Qualified Name">
            	<visibleWhen checkEnabled="false">
                	<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened" />
            	</visibleWhen>
         	</command>  
         </menuContribution>
         <menuContribution locationURI="popup:org.eclipse.xtext.ui.outline?after=additions">
			<command commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedName" 
				style="push" tooltip="Copy Qualified Name">
         		<visibleWhen checkEnabled="false">
	            	<and>
	            		<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.XtextEditor.opened" />
						<iterate>
							<adapt type="org.eclipse.xtext.ui.editor.outline.IOutlineNode" />
						</iterate>
					</and>
				</visibleWhen>
			</command>
         </menuContribution>
    </extension>
    <extension point="org.eclipse.ui.menus">
		<menuContribution locationURI="popup:#TextEditorContext?endof=group.find">
			<command commandId="org.eclipse.xtext.ui.editor.FindReferences">
				<visibleWhen checkEnabled="false">
                	<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
                	</reference>
            	</visibleWhen>
			</command>
		</menuContribution>
	</extension>
	<extension point="org.eclipse.ui.handlers">
	    <handler
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.findrefs.FindReferencesHandler"
            commandId="org.eclipse.xtext.ui.editor.FindReferences">
            <activeWhen>
                <reference
                    definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
                </reference>
            </activeWhen>
        </handler>
    </extension>   

<!-- adding resource factories -->

	<extension
		point="org.eclipse.emf.ecore.extension_parser">
		<parser
			class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.resource.IResourceFactory"
			type="datatype">
		</parser>
	</extension>
	<extension point="org.eclipse.xtext.extension_resourceServiceProvider">
        <resourceServiceProvider
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.resource.IResourceUIServiceProvider"
            uriExtension="datatype">
        </resourceServiceProvider>
    </extension>


    <!-- marker definitions for org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar -->
    <extension
            id="datatypegrammar.check.fast"
            name="DatatypeGrammar Problem"
            point="org.eclipse.core.resources.markers">
        <super type="org.eclipse.xtext.ui.check.fast"/>
        <persistent value="true"/>
    </extension>
    <extension
            id="datatypegrammar.check.normal"
            name="DatatypeGrammar Problem"
            point="org.eclipse.core.resources.markers">
        <super type="org.eclipse.xtext.ui.check.normal"/>
        <persistent value="true"/>
    </extension>
    <extension
            id="datatypegrammar.check.expensive"
            name="DatatypeGrammar Problem"
            point="org.eclipse.core.resources.markers">
        <super type="org.eclipse.xtext.ui.check.expensive"/>
        <persistent value="true"/>
    </extension>

   <extension
         point="org.eclipse.xtext.builder.participant">
      <participant
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.builder.IXtextBuilderParticipant">
      </participant>
   </extension>
   <extension
            point="org.eclipse.ui.preferencePages">
        <page
            category="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.builder.preferences.BuilderPreferencePage"
            id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.compiler.preferencePage"
            icon="icons/dsl_datatype.png"
            name="Compiler">
            <keywordReference id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"/>
        </page>
    </extension>
    <extension
            point="org.eclipse.ui.propertyPages">
        <page
            category="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.builder.preferences.BuilderPreferencePage"
            icon="icons/dsl_datatype.png"
            id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.compiler.propertyPage"
            name="Compiler">
            <keywordReference id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"/>
            <enabledWhen>
	            <adapt type="org.eclipse.core.resources.IProject"/>
			</enabledWhen>
	        <filter name="projectNature" value="org.eclipse.xtext.ui.shared.xtextNature"/>
        </page>
    </extension>
    <!-- quickfix marker resolution generator for org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar -->
    <extension
            point="org.eclipse.ui.ide.markerResolution">
        <markerResolutionGenerator
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator"
            markerType="org.eclipse.osbp.dsl.datatype.xtext.ui.datatypegrammar.check.fast">
            <attribute
                name="FIXABLE_KEY"
                value="true">
            </attribute>
        </markerResolutionGenerator>
        <markerResolutionGenerator
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator"
            markerType="org.eclipse.osbp.dsl.datatype.xtext.ui.datatypegrammar.check.normal">
            <attribute
                name="FIXABLE_KEY"
                value="true">
            </attribute>
        </markerResolutionGenerator>
        <markerResolutionGenerator
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator"
            markerType="org.eclipse.osbp.dsl.datatype.xtext.ui.datatypegrammar.check.expensive">
            <attribute
                name="FIXABLE_KEY"
                value="true">
            </attribute>
        </markerResolutionGenerator>
    </extension>

	<!-- Quick Outline -->
	<extension
		point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.outline.quickoutline.ShowQuickOutlineActionHandler"
			commandId="org.eclipse.xtext.ui.editor.outline.QuickOutline">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
	<extension
		point="org.eclipse.ui.commands">
		<command
			description="Open the quick outline."
			id="org.eclipse.xtext.ui.editor.outline.QuickOutline"
			name="Quick Outline">
		</command>
	</extension>
	<extension point="org.eclipse.ui.menus">
		<menuContribution
			locationURI="popup:#TextEditorContext?after=group.open">
			<command commandId="org.eclipse.xtext.ui.editor.outline.QuickOutline"
				style="push"
				tooltip="Open Quick Outline">
				<visibleWhen checkEnabled="false">
					<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened"/>
				</visibleWhen>
			</command>
		</menuContribution>
	</extension>

  <extension point="org.eclipse.compare.contentViewers">
    <viewer id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.compare.contentViewers"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.compare.InjectableViewerCreator"
            extensions="datatype">
    </viewer>
  </extension>
  <extension point="org.eclipse.compare.contentMergeViewers">
    <viewer id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.compare.contentMergeViewers"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.compare.InjectableViewerCreator"
            extensions="datatype" label="DatatypeGrammar Compare">
     </viewer>
  </extension>
  <extension point="org.eclipse.ui.editors.documentProviders">
    <provider id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.editors.documentProviders"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.model.XtextDocumentProvider"
            extensions="datatype">
    </provider>
  </extension>
   	<!-- Rename Refactoring -->
	<extension point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.refactoring.ui.DefaultRenameElementHandler"
			commandId="org.eclipse.xtext.ui.refactoring.RenameElement">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
    <extension point="org.eclipse.ui.menus">
         <menuContribution
            locationURI="popup:#TextEditorContext?after=group.edit">
         <command commandId="org.eclipse.xtext.ui.refactoring.RenameElement"
               style="push">
            <visibleWhen checkEnabled="false">
               <reference
                     definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
               </reference>
            </visibleWhen>
         </command>
      </menuContribution>
   </extension>
   <extension point="org.eclipse.ui.preferencePages">
	    <page
	        category="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar"
	        class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.refactoring.ui.RefactoringPreferencePage"
            icon="icons/dsl_datatype.png"
	        id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.refactoring"
	        name="Refactoring">
	        <keywordReference id="org.eclipse.osbp.dsl.datatype.xtext.ui.keyword_DatatypeGrammar"/>
	    </page>
	</extension>

<!-- Type Hierarchy  -->
	<extension
		point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.xbase.ui.hierarchy.OpenTypeHierarchyHandler"
			commandId="org.eclipse.xtext.xbase.ui.hierarchy.OpenTypeHierarchy">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
		<handler 
			class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.xbase.ui.hierarchy.QuickTypeHierarchyHandler"
			commandId="org.eclipse.jdt.ui.edit.text.java.open.hierarchy">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
	<extension point="org.eclipse.ui.menus">
		<menuContribution
			locationURI="popup:#TextEditorContext?after=group.open">
			<command commandId="org.eclipse.xtext.xbase.ui.hierarchy.OpenTypeHierarchy"
				style="push"
				tooltip="Open Type Hierarchy">
				<visibleWhen checkEnabled="false">
					<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened"/>
				</visibleWhen>
			</command>
		</menuContribution>
		<menuContribution
			locationURI="popup:#TextEditorContext?after=group.open">
			<command commandId="org.eclipse.jdt.ui.edit.text.java.open.hierarchy"
				style="push"
				tooltip="Quick Type Hierarchy">
				<visibleWhen checkEnabled="false">
					<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened"/>
				</visibleWhen>
			</command>
		</menuContribution>
	</extension>
	<!-- Call Hierachy -->
	<extension
		point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.xbase.ui.hierarchy.OpenCallHierachyHandler"
			commandId="org.eclipse.xtext.xbase.ui.hierarchy.OpenCallHierarchy">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
	
	<extension point="org.eclipse.ui.menus">
		<menuContribution
			locationURI="popup:#TextEditorContext?after=group.open">
			<command commandId="org.eclipse.xtext.xbase.ui.hierarchy.OpenCallHierarchy"
				style="push"
				tooltip="Open Call Hierarchy">
				<visibleWhen checkEnabled="false">
					<reference definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened"/>
				</visibleWhen>
			</command>
		</menuContribution>
	</extension>
	<extension
         point="org.eclipse.core.runtime.adapters">
      <factory class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.builder.smap.StratumBreakpointAdapterFactory"
         adaptableType="org.eclipse.xtext.ui.editor.XtextEditor">
         <adapter type="org.eclipse.debug.ui.actions.IToggleBreakpointsTarget"/>
      </factory> 
   </extension>
   <extension point="org.eclipse.ui.editorActions">
      <editorContribution targetID="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar" 
                          id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.ide.rulerActions">
	     <action
	             label="Not Used"
	             class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.debug.ui.actions.RulerToggleBreakpointActionDelegate"
	             style="push"
	             actionID="RulerDoubleClick"
	             id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.doubleClickBreakpointAction"/>
	  </editorContribution>
   </extension>
   <extension point="org.eclipse.ui.popupMenus">
      <viewerContribution
         targetID="example.rulerContextMenuId"
         id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.ide.RulerPopupActions">
         <action
            label="Toggle Breakpoint"
            class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.debug.ui.actions.RulerToggleBreakpointActionDelegate"
            menubarPath="additions"
            id="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.ide.rulerContextMenu.toggleBreakpointAction">
         </action>
      </viewerContribution>
   </extension>
   
    <!-- Introduce Local Variable Refactoring -->
	<extension point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.datatype.xtext.ui.DatatypeGrammarExecutableExtensionFactory:org.eclipse.xtext.xbase.ui.refactoring.ExtractVariableHandler"
			commandId="org.eclipse.xtext.xbase.ui.refactoring.ExtractLocalVariable">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
    <extension point="org.eclipse.ui.menus">
         <menuContribution
            locationURI="popup:#TextEditorContext?after=group.edit">
         <command commandId="org.eclipse.xtext.xbase.ui.refactoring.ExtractLocalVariable"
               style="push">
            <visibleWhen checkEnabled="false">
               <reference
                     definitionId="org.eclipse.osbp.dsl.datatype.xtext.DatatypeGrammar.Editor.opened">
               </reference>
            </visibleWhen>
         </command>
      </menuContribution>
   </extension>  

</plugin>
